#ifndef _NETINET_IN_H_
#define _NETINET_IN_H_
#ifndef ___uint8_t_def_
#define ___uint8_t_def_
typedef unsigned char __uint8_t;
#endif
#ifndef ___uint16_t_def_
#define ___uint16_t_def_
typedef unsigned short __uint16_t;
#endif
#ifndef ___uint32_t_def_
#define ___uint32_t_def_
typedef unsigned int __uint32_t;
#endif
#ifndef _uint8_t_def_
#define _uint8_t_def_
typedef __uint8_t uint8_t;
#endif
#ifndef _uint32_t_def_
#define _uint32_t_def_
typedef __uint32_t uint32_t;
#endif
#ifndef _u_char_def_
#define _u_char_def_
typedef unsigned char u_char;
#endif
#ifndef _u_short_def_
#define _u_short_def_
typedef unsigned short u_short;
#endif
#ifndef _u_int8_t_def_
#define _u_int8_t_def_
typedef __uint8_t u_int8_t;
#endif
#ifndef _u_int16_t_def_
#define _u_int16_t_def_
typedef __uint16_t u_int16_t;
#endif
#ifndef _u_int32_t_def_
#define _u_int32_t_def_
typedef __uint32_t u_int32_t;
#endif
#ifndef _in_addr_t_def_
#define _in_addr_t_def_
typedef u_int32_t in_addr_t;
#endif
#ifndef _in_port_t_def_
#define _in_port_t_def_
typedef u_int16_t in_port_t;
#endif
#ifndef _in_addr_def_
#define _in_addr_def_
struct in_addr{
  in_addr_t s_addr;
};
#endif
#ifndef _sockaddr_in_def_
#define _sockaddr_in_def_
struct sockaddr_in{
  u_char sin_len;
  u_char sin_family;
  u_short sin_port;
  struct in_addr sin_addr;
  char sin_zero[8];
};
#endif
#ifndef _in6_addr_def_
#define _in6_addr_def_
struct in6_addr{
  union {u_int8_t __u6_addr8[16];
	 u_int16_t __u6_addr16[8];
	 u_int32_t __u6_addr32[4];} __u6_addr;
};
#endif
#ifndef _sockaddr_in6_def_
#define _sockaddr_in6_def_
struct sockaddr_in6{
  u_int8_t sin6_len;
  u_int8_t sin6_family;
  u_int16_t sin6_port;
  u_int32_t sin6_flowinfo;
  struct in6_addr sin6_addr;
  u_int32_t sin6_scope_id;
};
#endif
#ifndef _in6addr_any_def_
#define _in6addr_any_def_
extern const struct in6_addr in6addr_any;
#endif
#ifndef _in6addr_loopback_def_
#define _in6addr_loopback_def_
extern const struct in6_addr in6addr_loopback;
#endif
#ifndef _ipv6_mreq_def_
#define _ipv6_mreq_def_
struct ipv6_mreq{
  struct in6_addr ipv6mr_multiaddr;
  unsigned int ipv6mr_interface;
};
#endif
#ifndef IPV6_MULTICAST_IF
#define IPV6_MULTICAST_IF 9 
#endif
#ifndef __IPV6_ADDR_SCOPE_ORGLOCAL
#define __IPV6_ADDR_SCOPE_ORGLOCAL 0x08 
#endif
#ifndef IPV6_MULTICAST_HOPS
#define IPV6_MULTICAST_HOPS 10 
#endif
#ifndef IPPROTO_IPV6
#define IPPROTO_IPV6 41 
#endif
#ifndef IN6_IS_ADDR_MC_NODELOCAL
#define IN6_IS_ADDR_MC_NODELOCAL(a) (IN6_IS_ADDR_MULTICAST(a) &&	(__IPV6_ADDR_MC_SCOPE(a) == __IPV6_ADDR_SCOPE_NODELOCAL)) 
#endif
#ifndef IPPROTO_IP
#define IPPROTO_IP 0 
#endif
#ifndef INET_ADDRSTRLEN
#define INET_ADDRSTRLEN 16 
#endif
#ifndef IN6_IS_ADDR_MC_LINKLOCAL
#define IN6_IS_ADDR_MC_LINKLOCAL(a) (IN6_IS_ADDR_MULTICAST(a) &&	(__IPV6_ADDR_MC_SCOPE(a) == __IPV6_ADDR_SCOPE_LINKLOCAL)) 
#endif
#ifndef IPV6_MULTICAST_LOOP
#define IPV6_MULTICAST_LOOP 11 
#endif
#ifndef IN6_IS_ADDR_MC_GLOBAL
#define IN6_IS_ADDR_MC_GLOBAL(a) (IN6_IS_ADDR_MULTICAST(a) &&	(__IPV6_ADDR_MC_SCOPE(a) == __IPV6_ADDR_SCOPE_GLOBAL)) 
#endif
#ifndef IPV6_LEAVE_GROUP
#define IPV6_LEAVE_GROUP 13 
#endif
#ifndef IN6_IS_ADDR_MC_SITELOCAL
#define IN6_IS_ADDR_MC_SITELOCAL(a) (IN6_IS_ADDR_MULTICAST(a) && (__IPV6_ADDR_MC_SCOPE(a) == __IPV6_ADDR_SCOPE_SITELOCAL)) 
#endif
#ifndef s6_addr
#define s6_addr __u6_addr.__u6_addr8 
#endif
#ifndef IN6_IS_ADDR_UNSPECIFIED
#define IN6_IS_ADDR_UNSPECIFIED(a) ((*(const u_int32_t *)(const void *)(&(a)->s6_addr[0]) == 0) &&	(*(const u_int32_t *)(const void *)(&(a)->s6_addr[4]) == 0) &&	(*(const u_int32_t *)(const void *)(&(a)->s6_addr[8]) == 0) &&	(*(const u_int32_t *)(const void *)(&(a)->s6_addr[12]) == 0)) 
#endif
#ifndef IN6_IS_ADDR_MULTICAST
#define IN6_IS_ADDR_MULTICAST(a) ((a)->s6_addr[0] == 0xff) 
#endif
#ifndef IPV6_UNICAST_HOPS
#define IPV6_UNICAST_HOPS 4 
#endif
#ifndef IPV6_JOIN_GROUP
#define IPV6_JOIN_GROUP 12 
#endif
#ifndef __IPV6_ADDR_SCOPE_NODELOCAL
#define __IPV6_ADDR_SCOPE_NODELOCAL 0x01 
#endif
#ifndef IN6_IS_ADDR_MC_ORGLOCAL
#define IN6_IS_ADDR_MC_ORGLOCAL(a) (IN6_IS_ADDR_MULTICAST(a) &&	(__IPV6_ADDR_MC_SCOPE(a) == __IPV6_ADDR_SCOPE_ORGLOCAL)) 
#endif
#ifndef __IPV6_ADDR_SCOPE_LINKLOCAL
#define __IPV6_ADDR_SCOPE_LINKLOCAL 0x02 
#endif
#ifndef __IPV6_ADDR_SCOPE_GLOBAL
#define __IPV6_ADDR_SCOPE_GLOBAL 0x0e 
#endif
#ifndef INADDR_ANY
#define INADDR_ANY (u_int32_t)0x00000000 
#endif
#ifndef __IPV6_ADDR_SCOPE_SITELOCAL
#define __IPV6_ADDR_SCOPE_SITELOCAL 0x05 
#endif
#ifndef IPPROTO_RAW
#define IPPROTO_RAW 255 
#endif
#ifndef IPPROTO_TCP
#define IPPROTO_TCP 6 
#endif
#ifndef IPPROTO_UDP
#define IPPROTO_UDP 17 
#endif
#ifndef IN6ADDR_ANY_INIT
#define IN6ADDR_ANY_INIT {{{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }}} 
#endif
#ifndef INADDR_BROADCAST
#define INADDR_BROADCAST (u_int32_t)0xffffffff 
#endif
#ifndef IPPROTO_ICMP
#define IPPROTO_ICMP 1 
#endif
#ifndef INET6_ADDRSTRLEN
#define INET6_ADDRSTRLEN 46 
#endif
#ifndef IPV6_V6ONLY
#define IPV6_V6ONLY 27 
#endif
#ifndef __IPV6_ADDR_MC_SCOPE
#define __IPV6_ADDR_MC_SCOPE(a) ((a)->s6_addr[1] & 0x0f) 
#endif
#ifndef IN6ADDR_LOOPBACK_INIT
#define IN6ADDR_LOOPBACK_INIT {{{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01 }}} 
#endif

  /* We'd like to do
     include {
     IN6_IS_ADDR_LINKLOCAL
     IN6_IS_ADDR_LOOPBACK
     IN6_IS_ADDR_SITELOCAL
     IN6_IS_ADDR_V4COMPAT
     IN6_IS_ADDR_V4MAPPED
     }
     but these bring in declarations for htonl and ntohl, which
     conflict with the declarations below.
  */

  /* These aren't defined in OS X or Cygwin so we guess :-( */
  #ifndef _in_port_t_def_
  #define _in_port_t_def_
  typedef unsigned short in_port_t;
  #endif
  #ifndef _in_addr_t_def_
  #define _in_addr_t_def_
  typedef unsigned int in_addr_t;
  #endif
  /* Not defined in OS X */
  #ifndef _sa_family_t_def_
  #define _sa_family_t_def_
  typedef unsigned char sa_family_t;
  #endif
#endif
