#ifndef _SIGNAL_H_
#define _SIGNAL_H_
#ifndef _pid_t_def_
#define _pid_t_def_
typedef int pid_t;
#endif
#ifndef _size_t_def_
#define _size_t_def_
typedef unsigned int size_t;
#endif
#ifndef _sigval_def_
#define _sigval_def_
union sigval{
  int sigval_int;
  void * sigval_ptr;
};
#endif
#ifndef _sigset_t_def_
#define _sigset_t_def_
typedef struct __sigset{
  unsigned int __bits[4];
} sigset_t;
#endif
#ifndef _sig_atomic_t_def_
#define _sig_atomic_t_def_
typedef int sig_atomic_t;
#endif
#ifndef ___siginfo_def_
#define ___siginfo_def_
struct __siginfo;
#endif
#ifndef _sigaction_def_
#define _sigaction_def_
struct sigaction{
  union {void (* __sa_handler)(int);
	 void (* __sa_sigaction)(int,struct __siginfo *,void *);} __sigaction_u;
  int sa_flags;
  sigset_t sa_mask;
};
#endif
#ifndef _stack_t_def_
#define _stack_t_def_
typedef struct sigaltstack{
  char * ss_sp;
  size_t ss_size;
  int ss_flags;
} stack_t;
#endif
#ifndef _mcontext_t_def_
#define _mcontext_t_def_
typedef struct __mcontext{
  int mc_onstack;
  int mc_gs;
  int mc_fs;
  int mc_es;
  int mc_ds;
  int mc_edi;
  int mc_esi;
  int mc_ebp;
  int mc_isp;
  int mc_ebx;
  int mc_edx;
  int mc_ecx;
  int mc_eax;
  int mc_trapno;
  int mc_err;
  int mc_eip;
  int mc_cs;
  int mc_eflags;
  int mc_esp;
  int mc_ss;
  int mc_fpregs[28];
  int __spare__[17];
} mcontext_t;
#endif
#ifndef _ucontext_t_def_
#define _ucontext_t_def_
typedef struct __ucontext{
  sigset_t uc_sigmask;
  mcontext_t uc_mcontext;
  struct __ucontext * uc_link;
  stack_t uc_stack;
  int __spare__[8];
} ucontext_t;
#endif
#ifndef _sigaction_def_
#define _sigaction_def_
int sigaction<`GR0::R,`GR1::R>(int,const struct sigaction *`GR0,struct sigaction *`GR1);
#endif
#ifndef _sigaltstack_def_
#define _sigaltstack_def_
int sigaltstack<`GR2::R,`GR3::R>(const stack_t *`GR2,stack_t *`GR3);
#endif
#ifndef SIGVTALRM
#define SIGVTALRM 26 
#endif
#ifndef SIGKILL
#define SIGKILL 9 
#endif
#ifndef SA_RESETHAND
#define SA_RESETHAND 0x0004 
#endif
#ifndef sa_sigaction
#define sa_sigaction __sigaction_u.__sa_sigaction 
#endif
#ifndef SA_NOCLDWAIT
#define SA_NOCLDWAIT 0x0020 
#endif
#ifndef SIGBUS
#define SIGBUS 10 
#endif
#ifndef SIGFPE
#define SIGFPE 8 
#endif
#ifndef SA_NOCLDSTOP
#define SA_NOCLDSTOP 0x0008 
#endif
#ifndef SIGILL
#define SIGILL 4 
#endif
#ifndef SIGINT
#define SIGINT 2 
#endif
#ifndef SIGHUP
#define SIGHUP 1 
#endif
#ifndef sa_handler
#define sa_handler __sigaction_u.__sa_handler 
#endif
#ifndef SIGPIPE
#define SIGPIPE 13 
#endif
#ifndef SA_ONSTACK
#define SA_ONSTACK 0x0001 
#endif
#ifndef SIGSEGV
#define SIGSEGV 11 
#endif
#ifndef SIGURG
#define SIGURG 16 
#endif
#ifndef SIGSYS
#define SIGSYS 12 
#endif
#ifndef SIGPROF
#define SIGPROF 27 
#endif
#ifndef SIGEV_SIGNAL
#define SIGEV_SIGNAL 1 
#endif
#ifndef SIGTERM
#define SIGTERM 15 
#endif
#ifndef SIGQUIT
#define SIGQUIT 3 
#endif
#ifndef SIGEV_NONE
#define SIGEV_NONE 0 
#endif
#ifndef SIGTRAP
#define SIGTRAP 5 
#endif
#ifndef SA_RESTART
#define SA_RESTART 0x0002 
#endif
#ifndef SIGABRT
#define SIGABRT 6 
#endif
#ifndef SIGSTOP
#define SIGSTOP 17 
#endif
#ifndef SIGTTIN
#define SIGTTIN 21 
#endif
#ifndef SIGXCPU
#define SIGXCPU 24 
#endif
#ifndef SIGTSTP
#define SIGTSTP 18 
#endif
#ifndef SIGTTOU
#define SIGTTOU 22 
#endif
#ifndef SIGUSR1
#define SIGUSR1 30 
#endif
#ifndef SIGUSR2
#define SIGUSR2 31 
#endif
#ifndef SIGXFSZ
#define SIGXFSZ 25 
#endif
#ifndef SIGALRM
#define SIGALRM 14 
#endif
#ifndef SIGCHLD
#define SIGCHLD 20 
#endif
#ifndef SA_NODEFER
#define SA_NODEFER 0x0010 
#endif
#ifndef SIGCONT
#define SIGCONT 19 
#endif
#ifndef SIG_BLOCK
#define SIG_BLOCK 1 
#endif
#ifndef SIG_SETMASK
#define SIG_SETMASK 3 
#endif
#ifndef SA_SIGINFO
#define SA_SIGINFO 0x0040 
#endif
#ifndef SIG_UNBLOCK
#define SIG_UNBLOCK 2 
#endif

  // We'd like to
  // include { sigevent sigval stack_t sigstack siginfo_t }
  // but in Linux this pulls in structures that contain void *'s.

  // If SIG_HOLD is defined in the C library, it is defined as an
  // integer cast to a function pointer, which won't be allowed in
  // Cyclone, so we undef it here.  We define _SIG_HOLD_def_ to
  // remember that we should support it, though.
  #ifdef SIG_HOLD
  #define _SIG_HOLD_def_
  #undef SIG_HOLD
  #endif

  extern "C" int kill(pid_t, int);

  extern "C" int raise(int);

  extern "C" int sigaddset(sigset_t@, int);  

  extern "C" int sigdelset(sigset_t@, int);

  extern "C" int sigemptyset(sigset_t@);

  extern "C" int sigfillset(sigset_t@);

  extern "C" int siginterrupt(int,int);

  extern "C" int sigismember(sigset_t@, int);

  extern "C" int sigpause(int);

  typedef void (@sigarg_t)(int);
  extern void SIG_DFL(int);
  extern void SIG_ERR(int);
  extern void SIG_IGN(int);
  #ifdef _SIG_HOLD_def_
  extern void SIG_HOLD(int); // Rare
  #endif

  extern sigarg_t signal(int, sigarg_t);

  extern int sigaction(int, struct sigaction *, struct sigaction *);
  extern "C" struct sigaction fresh_sigaction();
#endif
