#ifndef _SYS_RESOURCE_H_
#define _SYS_RESOURCE_H_
#ifndef ___int64_t_def_
#define ___int64_t_def_
typedef int __int64_t;
#endif
#ifndef ___uint64_t_def_
#define ___uint64_t_def_
typedef unsigned int __uint64_t;
#endif
#ifndef _int64_t_def_
#define _int64_t_def_
typedef __int64_t int64_t;
#endif
#ifndef _u_int64_t_def_
#define _u_int64_t_def_
typedef __uint64_t u_int64_t;
#endif
#ifndef _u_quad_t_def_
#define _u_quad_t_def_
typedef u_int64_t u_quad_t;
#endif
#ifndef _quad_t_def_
#define _quad_t_def_
typedef int64_t quad_t;
#endif
#ifndef _rlim_t_def_
#define _rlim_t_def_
typedef quad_t rlim_t;
#endif
#ifndef _timeval_def_
#define _timeval_def_
struct timeval{
  long tv_sec;
  long tv_usec;
};
#endif
#ifndef _rusage_def_
#define _rusage_def_
struct rusage{
  struct timeval ru_utime;
  struct timeval ru_stime;
  long ru_maxrss;
  long ru_ixrss;
  long ru_idrss;
  long ru_isrss;
  long ru_minflt;
  long ru_majflt;
  long ru_nswap;
  long ru_inblock;
  long ru_oublock;
  long ru_msgsnd;
  long ru_msgrcv;
  long ru_nsignals;
  long ru_nvcsw;
  long ru_nivcsw;
};
#endif
#ifndef _rlimit_def_
#define _rlimit_def_
struct rlimit{
  rlim_t rlim_cur;
  rlim_t rlim_max;
};
#endif
#ifndef RLIM_INFINITY
#define RLIM_INFINITY ((rlim_t)(((u_quad_t)1 << 63) - 1)) 
#endif
#ifndef RUSAGE_SELF
#define RUSAGE_SELF 0 
#endif
#ifndef RLIMIT_FSIZE
#define RLIMIT_FSIZE 1 
#endif
#ifndef PRIO_PGRP
#define PRIO_PGRP 1 
#endif
#ifndef RUSAGE_CHILDREN
#define RUSAGE_CHILDREN -1 
#endif
#ifndef RLIMIT_DATA
#define RLIMIT_DATA 2 
#endif
#ifndef PRIO_PROCESS
#define PRIO_PROCESS 0 
#endif
#ifndef RLIMIT_STACK
#define RLIMIT_STACK 3 
#endif
#ifndef RLIMIT_CORE
#define RLIMIT_CORE 4 
#endif
#ifndef RLIMIT_CPU
#define RLIMIT_CPU 0 
#endif
#ifndef PRIO_USER
#define PRIO_USER 2 
#endif
#ifndef RLIMIT_NOFILE
#define RLIMIT_NOFILE 8 
#endif

  /* OS X doesn't define id_t */
  #ifndef _id_t_def_
  #define _id_t_def_
  typedef int id_t;
  #endif
  extern "C" int getpriority(int, id_t);

  extern "C" int getrlimit(int, struct rlimit @);

  extern "C" int getrusage(int, struct rusage @);

  extern "C" int setpriority(int, id_t, int);

  extern "C" int setrlimit(int, const struct rlimit @);
#endif
