#ifndef _SYS_STAT_H_
#define _SYS_STAT_H_
#ifndef ___int64_t_def_
#define ___int64_t_def_
typedef int __int64_t;
#endif
#ifndef ___uint16_t_def_
#define ___uint16_t_def_
typedef unsigned short __uint16_t;
#endif
#ifndef ___int32_t_def_
#define ___int32_t_def_
typedef int __int32_t;
#endif
#ifndef ___uint32_t_def_
#define ___uint32_t_def_
typedef unsigned int __uint32_t;
#endif
#ifndef _int32_t_def_
#define _int32_t_def_
typedef __int32_t int32_t;
#endif
#ifndef _int64_t_def_
#define _int64_t_def_
typedef __int64_t int64_t;
#endif
#ifndef _u_int16_t_def_
#define _u_int16_t_def_
typedef __uint16_t u_int16_t;
#endif
#ifndef _u_int32_t_def_
#define _u_int32_t_def_
typedef __uint32_t u_int32_t;
#endif
#ifndef _gid_t_def_
#define _gid_t_def_
typedef u_int32_t gid_t;
#endif
#ifndef _ino_t_def_
#define _ino_t_def_
typedef u_int32_t ino_t;
#endif
#ifndef _mode_t_def_
#define _mode_t_def_
typedef u_int16_t mode_t;
#endif
#ifndef _nlink_t_def_
#define _nlink_t_def_
typedef u_int16_t nlink_t;
#endif
#ifndef _off_t_def_
#define _off_t_def_
typedef __int64_t off_t;
#endif
#ifndef _uid_t_def_
#define _uid_t_def_
typedef u_int32_t uid_t;
#endif
#ifndef _dev_t_def_
#define _dev_t_def_
typedef u_int32_t dev_t;
#endif
#ifndef _time_t_def_
#define _time_t_def_
typedef long time_t;
#endif
#ifndef _timespec_def_
#define _timespec_def_
struct timespec{
  time_t tv_sec;
  long tv_nsec;
};
#endif
#ifndef _stat_def_
#define _stat_def_
struct stat{
  dev_t st_dev;
  ino_t st_ino;
  mode_t st_mode;
  nlink_t st_nlink;
  uid_t st_uid;
  gid_t st_gid;
  dev_t st_rdev;
  struct timespec st_atimespec;
  struct timespec st_mtimespec;
  struct timespec st_ctimespec;
  off_t st_size;
  int64_t st_blocks;
  u_int32_t st_blksize;
  u_int32_t st_flags;
  u_int32_t st_gen;
  int32_t st_lspare;
  int64_t st_qspare[2];
};
#endif
#ifndef _stat_def_
#define _stat_def_
int stat<`GR4::R,`GR5::R>(const char *`GR4,struct stat *`GR5);
#endif
#ifndef S_IRWXG
#define S_IRWXG 0000070 
#endif
#ifndef S_IRWXO
#define S_IRWXO 0000007 
#endif
#ifndef S_IRWXU
#define S_IRWXU 0000700 
#endif
#ifndef S_ISVTX
#define S_ISVTX 0001000 
#endif
#ifndef S_IWGRP
#define S_IWGRP 0000020 
#endif
#ifndef S_IXGRP
#define S_IXGRP 0000010 
#endif
#ifndef S_IWOTH
#define S_IWOTH 0000002 
#endif
#ifndef S_IXOTH
#define S_IXOTH 0000001 
#endif
#ifndef S_IFBLK
#define S_IFBLK 0060000 
#endif
#ifndef S_IFCHR
#define S_IFCHR 0020000 
#endif
#ifndef S_IWUSR
#define S_IWUSR 0000200 
#endif
#ifndef S_IFDIR
#define S_IFDIR 0040000 
#endif
#ifndef S_IXUSR
#define S_IXUSR 0000100 
#endif
#ifndef S_IFIFO
#define S_IFIFO 0010000 
#endif
#ifndef S_IFLNK
#define S_IFLNK 0120000 
#endif
#ifndef S_ISFIFO
#define S_ISFIFO(m) (((m) & 0170000) == 0010000) 
#endif
#ifndef S_IFMT
#define S_IFMT 0170000 
#endif
#ifndef S_IFREG
#define S_IFREG 0100000 
#endif
#ifndef st_atime
#define st_atime st_atimespec.tv_sec 
#endif
#ifndef S_IFSOCK
#define S_IFSOCK 0140000 
#endif
#ifndef st_mtime
#define st_mtime st_mtimespec.tv_sec 
#endif
#ifndef S_ISBLK
#define S_ISBLK(m) (((m) & 0170000) == 0060000) 
#endif
#ifndef S_ISCHR
#define S_ISCHR(m) (((m) & 0170000) == 0020000) 
#endif
#ifndef S_ISDIR
#define S_ISDIR(m) (((m) & 0170000) == 0040000) 
#endif
#ifndef S_IRGRP
#define S_IRGRP 0000040 
#endif
#ifndef S_ISGID
#define S_ISGID 0002000 
#endif
#ifndef st_ctime
#define st_ctime st_ctimespec.tv_sec 
#endif
#ifndef S_ISLNK
#define S_ISLNK(m) (((m) & 0170000) == 0120000) 
#endif
#ifndef S_IROTH
#define S_IROTH 0000004 
#endif
#ifndef S_ISREG
#define S_ISREG(m) (((m) & 0170000) == 0100000) 
#endif
#ifndef S_ISSOCK
#define S_ISSOCK(m) (((m) & 0170000) == 0140000) 
#endif
#ifndef S_IRUSR
#define S_IRUSR 0000400 
#endif
#ifndef S_ISUID
#define S_ISUID 0004000 
#endif

  // EXTREMELY irritating: under Linux, mode_t, etc., are not defined
  // in sys/stat.h, CONTRARY to the posix spec.  Instead __mode_t, etc.,
  // are defined.  This makes mode_t, etc., defined under Linux.
  #if defined(___blkcnt_t_def_) && !defined(_blkcnt_t_def_)
  #define _blkcnt_t_def_
  typedef __blkcnt_t blkcnt_t;
  #endif
  #if defined(___blksize_t_def_) && !defined(_blksize_t_def_)
  #define _blksize_t_def_
  typedef __blksize_t blksize_t;
  #endif
  #if defined(___dev_t_def_) && !defined(_dev_t_def_)
  #define _dev_t_def_
  typedef __dev_t dev_t;
  #endif
  #if defined(___ino_t_def_) && !defined(_ino_t_def_)
  #define _ino_t_def_
  typedef __ino_t ino_t;
  #endif
  #if defined(___mode_t_def_) && !defined(_mode_t_def_)
  #define _mode_t_def_
  typedef __mode_t mode_t;
  #endif
  #if defined(___nlink_t_def_) && !defined(_nlink_t_def_)
  #define _nlink_t_def_
  typedef __nlink_t nlink_t;
  #endif
  #if defined(___uid_t_def_) && !defined(_uid_t_def_)
  #define _uid_t_def_
  typedef __uid_t uid_t;
  #endif
  #if defined(___gid_t_def_) && !defined(_gid_t_def_)
  #define _gid_t_def_
  typedef __gid_t gid_t;
  #endif
  #if defined(___off_t_def_) && !defined(_off_t_def_)
  #define _off_t_def_
  typedef __off_t off_t;
  #endif
  #if defined(___time_t_def_) && !defined(_time_t_def_)
  #define _time_t_def_
  typedef __time_t time_t;
  #endif
  /* Cygwin needs these definitions to smooth out the interface */
  #if defined(__CYGWIN32__) || defined(__CYGWIN__)
  #ifdef __CYGWIN_USE_BIG_TYPES__
  #define st_uid  __st_uid32
  #define st_gid  __st_gid32
  #define st_size __st_size64
  #else
  #define st_uid  __st_uid16
  #define st_gid  __st_gid16
  #define st_size __st_size32
  #endif /* __CYGWIN_USE_BIG_TYPES__ */
  #endif /* defined(__CYGWIN32__) || defined(__CYGWIN__) */

  extern "C" int chmod(const char @, mode_t);

  extern "C" int fchmod(int, mode_t);

  extern "C" int fstat(int fd, struct stat @buf);

  extern "C" int lstat(const char @ filename, struct stat @buf);

  extern "C" int mkdir(const char @ pathname, mode_t mode);

  extern "C" int mkfifo(const char @ pathname, mode_t mode);

  extern "C" int mknod(const char @ pathname, mode_t mode, dev_t);

  extern "C" int stat(const char @, struct stat @);

  extern "C" mode_t umask(mode_t mask);
#endif
