#ifndef _SYS_WAIT_H_
#define _SYS_WAIT_H_
#ifndef _pid_t_def_
#define _pid_t_def_
typedef int pid_t;
#endif
#ifndef _rusage_def_
#define _rusage_def_
struct rusage;
#endif
#ifndef WIFSIGNALED
#define WIFSIGNALED(x) (_WSTATUS(x) != _WSTOPPED && _WSTATUS(x) != 0) 
#endif
#ifndef WTERMSIG
#define WTERMSIG(x) (_WSTATUS(x)) 
#endif
#ifndef _WSTOPPED
#define _WSTOPPED 0177 
#endif
#ifndef WUNTRACED
#define WUNTRACED 2 
#endif
#ifndef _WSTATUS
#define _WSTATUS(x) (_W_INT(x) & 0177) 
#endif
#ifndef WNOHANG
#define WNOHANG 1 
#endif
#ifndef _W_INT
#define _W_INT(w) (*(int *)&(w)) 
#endif
#ifndef WIFEXITED
#define WIFEXITED(x) (_WSTATUS(x) == 0) 
#endif
#ifndef WIFSTOPPED
#define WIFSTOPPED(x) (_WSTATUS(x) == _WSTOPPED) 
#endif
#ifndef WSTOPPED
#define WSTOPPED _WSTOPPED 
#endif
#ifndef WSTOPSIG
#define WSTOPSIG(x) (_W_INT(x) >> 8) 
#endif
#ifndef WEXITSTATUS
#define WEXITSTATUS(x) (_W_INT(x) >> 8) 
#endif

  /* siginfo_t is omitted because it contains a pointer */
  /* waitid is omitted because it needs siginfo_t */
  /*
    extern "C" int waitid(idtype_t, id_t, siginfo_t @, int);
  */

  // EXTREMELY irritating: under Linux, pid_t is not defined
  // in sys/wait.h, CONTRARY to the posix spec.  Instead __pid_t
  // is defined.  So we include __pid_t above and do the following:
  #if defined(___pid_t_def_) && !defined(_pid_t_def_)
  #define _pid_t_def_
  typedef __pid_t pid_t;
  #endif

  extern "C" pid_t wait(int *);

  #define HAVE_WAITPID
  extern "C" pid_t waitpid(pid_t, int *, int);
#endif
